/*
 * Copyright (C) 2009 Jeferson Hultmann <hultmann@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const EXPORTED_SYMBOLS = ["buttonCmd", "buttonTooltip"];
const NS_XUL = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

Components.utils.import("resource://hultmann-migre-me-modules/util.js");


function buttonCmd(command) {
  var win = command.ownerDocument.defaultView;
  var browser = win.getBrowser().selectedBrowser;
  var uri = browser.contentDocument.documentURIObject;

  util.log('onCommand ' + uri.spec);


  Components.utils.import("resource://hultmann-migre-me-modules/redir-storage.js");
  var redir = redirStorage.getSavedRedir(uri);
  if (redir) {
    util.toClipboard(redir);
    return;
  }

  function onSuccess(info) {
    util.toClipboard(info.shortUri.spec);
  }

  util.toTinyUrlRequest(uri, browser, onSuccess);
  util.toClipboard("");
}


function buttonTooltip(tooltip) {
  var win = tooltip.ownerDocument.defaultView;
  var uri = win.getBrowser().selectedBrowser.contentDocument.documentURIObject;
  var text;

  Components.utils.import("resource://hultmann-migre-me-modules/redir-storage.js");
  var redir = redirStorage.getSavedRedir(uri);
  if (redir) {
    text = util.getText("button.create.saved.tooltip", redir);
  } else {
    text = util.getText("button.create.new.tooltip");
  }
  tooltip.setAttribute("label", text);
}
