/*
 * Copyright (C) 2009 Jeferson Hultmann <hultmann@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const EXPORTED_SYMBOLS = ["Cc", "Ci", "util"];

const Cc = Components.classes;
const Ci = Components.interfaces;


const util = {

  //assert: function() {


  toTinyUrlRequest: function(uri, browserOrigin, onSuccess, error) {
    if (this.isRedirUri(uri)) {
      throw util.myThrow(host);
    }


    var chromeWnd = browserOrigin.ownerDocument.defaultView;
    chromeWnd.setCursor("progress");
    //chromeWnd.getBrowser().selectedBrowser.defaultView.setCursor('progress');

    Components.utils.import("resource://hultmann-migre-me-modules/api-migreme.js");
    var req = new AsyncRequest();
    var start = new Date().getTime();

    //req.onStart = function() {
      /*
      var e = chromeWnd.document.documentElement;
      util.log('onstart ['+e.className+']');
      e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';


      e = chromeWnd.getBrowser().selectedBrowser.contentDocument.body;
      util.log('onstart ['+e.className+']');
      e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';
      */
    //};

    req.onComplete = function() {
      chromeWnd.setCursor("auto");
      util.log("migre.me connection: " + (new Date().getTime() - start) + "ms");
      /*
      var e = chromeWnd.document.documentElement;
      util.log('onstop ['+e.className+']');
      var t = e.className.split(/\s+/).map(function(i) {
        return i == 'migreme-hltmnn-progress' ? '' : i;
      });
      e.className = t.join(" ");
      */
      //util.log('cursor auto');
    };

    req.onSuccess = function(info) {
      onSuccess(info);
      Components.utils.import("resource://hultmann-migre-me-modules/redir-storage.js");
      redirStorage.saveShortUrl(uri, info.shortUri);
    };


    if (error) {
      req.onError = error;
    } else {
      req.onError = function(errData) {
        Components.utils.import("resource://hultmann-migre-me-modules/err.js");
        notificationError(errData, browserOrigin);
      }
    }

    req.convert(uri);
  },


  isRedirUri: function(uri) {
    var tld = Cc["@mozilla.org/network/effective-tld-service;1"]
              .getService(Ci.nsIEffectiveTLDService);

    var baseDomain;
    try {
      baseDomain = tld.getBaseDomain(uri);
    } catch (ex) {
      return false; //e.g.: localhost
    }

    //util.log(uri.host + "\n"+tld.getBaseDomain(uri));
    //util.log("baseDomain="+baseDomain);
    //util.log("publicSuffix="+publicSuffix);


    // no path
    if (uri.path.length === 1) { // "/".length=1
      var publicSuffix = tld.getPublicSuffix(uri);
      if (publicSuffix === "tk") { // http://ura71.tk
        return true;
      }

      switch (baseDomain) {
        case "th8.us":
          return true;
      }
      return false;
    }


    switch (baseDomain) {
      case "3.ly":  // "3.ly/aaa" ==> "3.ly/aaa/" ==> url
        return true;
    }


    // path=/xxxx/
    if (uri.path.indexOf("/", 1) > 0) {
      switch (baseDomain) {
        case "flic.kr":
        case "flickr.com":
          return uri.path.indexOf("/p/") === 0;
        case "google.com":
          return uri.host === "feedproxy.google.com";
      }
      return false;
    }



    switch (baseDomain) {

      case "th8.us":
        return uri.path.indexOf("/forw") === 0; // http://th8.us/forward.php?xyz

      case "tk":

      case "blip.fm":
        return uri.path.indexOf("/~") === 0 || uri.path.indexOf("/%7E") === 0;

      case "tumblr.com":
      case "digg.com":
        //return uri.path.indexOf("/", 1) === -1;


      case "trunc.it":

      case "307.to":
      case "adjix.com":
      case "b23.ru":
      case "bacn.me":
      case "bit.ly":
      case "bloat.me":
      case "budurl.com":
      case "chilp.it":
      case "cli.gs":
      case "clipurl.us":
      case "cort.as":
      case "dwarfurl.com":
      case "ff.im":
      case "fff.to":
      case "fit.am":
      case "href.in":
      case "idek.net":
      case "is.gd":
      case "j.mp":
      case "kl.am":
      case "korta.nu":
      case "lin.cr":
      case "ln-s.net":
      case "loopt.us":
      case "lost.in":
      case "memurl.com":
      case "merky.de":
      case "migre.me":
      case "moby.to":
      case "moourl.com":
      case "nanourl.se":
      case "notlong.com":
      case "oia.la":
      case "ow.ly":
      case "peaurl.com":
      case "ping.fm":
      case "piurl.com":
      case "plurl.me":
      case "pnt.me":
      case "poprl.com":
      case "post.ly":
      case "qlnk.net":
      case "rde.me":
      case "reallytinyurl.com":
      case "redir.ec":
      case "retwt.me":
      case "rubyurl.com":
      case "short.ie":
      case "short.to":
      case "siga.st":
      case "smallr.com":
      case "sn.im":
      case "sn.vc":
      case "snipr.com":
      case "snipurl.com":
      case "snurl.com":
      case "su.pr":
      case "tiny.cc":
      case "tinysong.com":
      case "tinysong.com":
      case "tinyurl.com":
      case "tl.gd":
      case "togoto.us":
      case "tr.im":
      case "tra.kz":
      case "trg.li":
      case "trim.li":
      case "twurl.cc":
      case "twurl.nl":
      case "u.mavrev.com":
      case "u.nu":
      case "uiop.me":
      case "ur1.ca":
      case "url.az":
      case "url.ie":
      case "urlx.ie":
      case "vai.la":
      case "w34.us":
      case "wp.me":
      case "xrl.us":
      case "yep.it":
      case "zi.ma":
      case "zip.li":
      case "zurl.ws":
      case "xurls.info":
      case "icio.us":


      case "xn--hgi.ws": // ➡
      case "xn--ogi.ws": // ➨
      case "xn--vgi.ws": // ➯
      case "xn--3fi.ws": // ➔
      case "xn--egi.ws": // ➞
      case "xn--9gi.ws": // ➽
      case "xn--5gi.ws": // ➹
      case "xn--1ci.ws": // ✩
      case "xn--odi.ws": // ✿
      case "xn--rei.ws": // ❥
      case "xn--cwg.ws": // ›
      case "xn--bih.ws": // ⌘
      case "xn--fwg.ws": // ‽
      case "xn--l3h.ws": // ☁
      case "ta.gd":

        return true;
    }

    return false;
  },


  getInfoUrl: function(uri) {
    var tld = Cc["@mozilla.org/network/effective-tld-service;1"]
                .getService(Ci.nsIEffectiveTLDService);
    var baseDomain = tld.getBaseDomain(uri);

    switch (baseDomain) {
      case "j.mp":
      case "bit.ly":
        return uri.spec + "+";
      case "3.ly":
        if (uri.path.lastIndexOf("/") === (uri.path.length - 1)) {
          return null;
        } else {
          return uri.spec + "-";
        }
      case "is.gd":
        return uri.spec + "-";
      case "migre.me":
        return "http://migre.me/contar-cliques/?url=" + uri.path.substr(1);
      case "uiop.me":
        return "http://uiop.me/consultar/?link=" + uri.path.substr(1);
      case "oia.la":
        return "http://oia.la/log.php?tp=clique&link=" + uri.path.substr(1);
      case "vai.la":
        return "http://vai.la/link/info/code/" + uri.path.substr(1);
      case "th8.us":
        if (uri.host !== baseDomain) { // "xxxxx.th8.us" vs. "th8.us"
          var uri2 = uri.clone();
          uri2.host = "p." + uri.host;
          return uri2.spec;
        }
        break;
    }

    return null;
  },


  toClipboard: function(txt) {
    Cc["@mozilla.org/widget/clipboardhelper;1"]
      .getService(Ci.nsIClipboardHelper)
      .copyString(txt);
  },


  isOffline: function() {
    return Cc["@mozilla.org/network/io-service;1"]
            .getService(Ci.nsIIOService2)
            .offline;
  },


  openPage: function(url, where, chromeWin) {
    if (util.checkSecurity(util.stringToUri(url)) === false) {
      util.log("openPage security false " + url);
      return;
    }

    if (chromeWin === null) {
      chromeWin = Cc["@mozilla.org/appshell/window-mediator;1"]
                  .getService(Ci.nsIWindowMediator)
                  .getMostRecentWindow("navigator:browser");
    }

    //var referer = chromeWin.getBrowser().selectedBrowser.contentDocument.documentURIObject;
    chromeWin.openUILinkIn(url, where);
    chromeWin.content.focus();
  },


  openPage2: function(evt, url, close) {
    var menuItem = evt.target;
    var chromeWin = menuItem.ownerDocument.defaultView;
    var where;

    switch (evt.type) {
      case "click":
        if ((menuItem.getAttribute("disabled") === "true")
        || (evt.button !== 1)) {
          return; // do nothing
        }
        where = "tabshifted";
        break;
      case "command":
        where = "current";
        break;
      default:
        throw evt.type;
    }

    if (close) {
      chromeWin.closeMenus(menuItem);
    }

    util.openPage(url, where, chromeWin);
  },


  pageTitle: function(uri) {
    return Cc["@mozilla.org/browser/nav-history-service;1"]
      .getService(Ci.nsINavHistoryService)
      .getPageTitle(uri);
  },


/*
  getLocationHeader: function(xhr2) {

    var url = xhr2.getResponseHeader("Location");
    if (url === null) {
      return null;
    }

    var uri;
    if (url.indexOf("/") === 0) { // url="/path"
      uri = xhr2.channel.originalURI.clone();
      uri.path = url;
    } else {
      uri = util.stringToUri(url);
    }

    return uri;
  },
*/

  _toArray: function(webOnly, theStack) {
    var allItems = [];
    if (!theStack) {
      //$.moz.prompt('theStack undef\n'+$.stack.toString(false, Components.stack))
      return allItems;
    }

    function StackItem() {
    }
    StackItem.prototype = {
      lang: '?',
      filename: '?',
      lineNumber: -1,
      name: '?'
    };

    // aparentemente é um bug que ocorre as vezes, todas as propriedades sao undefined
    if (theStack.languageName == undefined) {
      //$.moz.prompt('myStack\n'+myStack +  '\n\ntheStack\n'+theStack + '\n\nallItems\n' + allItems.join('\n') + '\n\n\n'+$.stack.toString(false, Components.stack))
      var item = new StackItem();
      item.name = theStack.toString();
      allItems.push(item);
    }

    //for (var myStack = theStack; myStack !== null; myStack = myStack.caller) {
    //    $.moz.prompt('myStack\n'+myStack);
    //}

    // myStack.caller é quase sempre null, mas algumas vezes é undefined...
    for (var myStack = theStack; myStack; myStack = myStack.caller) {
      if (webOnly) {
        var n = myStack.filename;
        if (n === null) {
          continue;
        }
        if ((n.indexOf("http:") !== 0) && (n.indexOf("https:") !== 0)) {
          continue;
        }
      }


      var item = new StackItem();
      allItems.push(item);
      item.lang = myStack.languageName;
      item.filename = myStack.filename;
      item.lineNumber = myStack.lineNumber; // Valid line numbers begin at '1'. '0' indicates unknown.
      item.name = myStack.name;
    }

    allItems.reverse();
    return allItems;
  },

  _toString: function(webOnly, theStack) {
    var arr = this._toArray(webOnly, theStack);
    var lines = new Array(arr.length);
    for (var idx = 0, len = arr.length; idx < len; idx++) {
      var lang = webOnly ? '' : arr[idx].lang + ' ';
      lines[idx] = '[' + (idx + 1) + '] '
                  + lang
                  + arr[idx].filename + ' '
                  + arr[idx].name + ' ('
                  + arr[idx].lineNumber + ')';
    }
    return lines.join("\n");
  },

  myThrow: function(txt) {
    this.log('Stack:\n' + this._toString(false, Components.stack));
    throw txt;
  },


  checkSecurity: function (uri) {
    switch (uri.scheme) {
      case "javascript":
      case "data":
        return false;
    }
    return true;
  },


  addClass: function(node, newClass) {
    var current = node.className;
    if (current.length > 0) {
      node.className = current + " " + newClass;
    } else {
      node.className = newClass;
    }
  },

  stringToUri: function(spec) {
    try {
      return Cc["@mozilla.org/network/io-service;1"]
              .getService(Ci.nsIIOService)
              .newURI(spec, "UTF-8", null);
    } catch (ex) {
      return null;
    }
  },

  getText: function(msg) {
    var qty = arguments.length - 1;
    var args = new Array(qty);
    for (var idx = 0; idx < qty; idx++) {
      args[idx] = arguments[idx + 1];
    }
    return Cc["@mozilla.org/intl/stringbundle;1"]
            .getService(Ci.nsIStringBundleService)
            .createBundle("chrome://hultmann-migre-me-content/locale/general.properties")
            .formatStringFromName(msg, args, args.length);
  },

  log: function(msg) {//status stat
    var now = new Date();
    var p = "hultmann-migre-me-content[" + now.toLocaleTimeString() + "." + now.getMilliseconds() + "] ";
    dump("\n------------------------------------------------------------------\n" + p + msg);
    Cc["@mozilla.org/consoleservice;1"]
      .getService(Ci.nsIConsoleService)
      .logStringMessage(p + msg);
  },

  findCurrentUrlPos: function(txt, idx) {
    //var bounds = ["http:", "https:", "ftp:", "www."];
    var bounds = [" ", "\n", "\t", "(", ")", '"', "'", "<", ">", "[", "]"];
    var mySort = function(a, b) {
      return a - b;
    };

    var stopChars = bounds.map(function(myChar) {
      var idx2 = txt.indexOf(myChar, idx);
      return idx2 === -1 ? Infinity : idx2;
    });


    stopChars.sort(mySort);
    var endNearest = stopChars[0];
    var lastChar = (endNearest === Infinity ? txt.length : endNearest) - 1;


    var startChars = bounds.map(function(myChar) {
      return txt.lastIndexOf(myChar, lastChar);
    });

    startChars.sort(mySort);
    var startNearest = startChars[startChars.length - 1];

    var firstChar = startNearest == -1 ? 0 : startNearest + 1;
    return [firstChar, lastChar - firstChar + 1];
  }

};


